<id>
Gravatar Support - Version 1.0 for YaBB 2.4
</id>

<version>
1.0
</version>

<mod info>
Adds Gravatar support to YaBB.

Mod History:
Version 1.0 - First Release - 23rd June 2009

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
 
Files to edit 
Admin/ModList.pl
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/Load.pl
Sources/Profile.pl
Sources/System.pl
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$mod_gravatar = "Gravatar Support|Derek Barnstorm|Adds Gravatar support to YaBB.|1.0|23rd June 2009";
	push (@installed_mods, "$mod_gravatar");
</add before>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$avatar_dirlimit = $avatar_dirlimit;			# set to the maximum size of the upload avatar directory, 0 == no limit
</search for>

<add after>

\$enable_gravatar = $enable_gravatar;	              # Set to 1 if you want to enable members to select Gravatar
\$enable_gravatarall = $enable_gravatarall;           # Set to 1 if you want to enable Gravatar for all members
\$gravatar_size = $gravatar_size;			          # Set the size of the Gravatar
\$gravatar_rating = "\Q$gravatar_rating\E";           # Set Gravatar rating
\$gravatar_defaulturl = "\Q$gravatar_defaulturl\E";   # Set the default image for Gravatar
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
		{
			description => $admin_txt{'extendedprofiles'},
			input_html => qq~<input type="checkbox" name="extendedprofiles" value="1" ${ischecked($extendedprofiles)}/>~,
			name => 'extendedprofiles',
			validate => 'boolean',
		},
</search for>

<add after>
		{
			header => $settings_txt{'gravatar'},
		},
		{
			description => $admin_txt{'grav1'},
			input_html => qq~<input type="checkbox" name="enable_gravatar" value="1"${ischecked($enable_gravatar)} />~,
			name => 'enable_gravatar',
			validate => 'boolean',
			depends_on => ['!enable_gravatarall'],
		},
		{
			description => $admin_txt{'grav2'},
			input_html => qq~<input type="checkbox" name="enable_gravatarall" value="1"${ischecked($enable_gravatarall)} />~,
			name => 'enable_gravatarall',
			validate => 'boolean',
	    	depends_on => ['!enable_gravatar'],
		},
		{
			description => $admin_txt{'grav3'},
			input_html => qq~<input type="text" name="gravatar_size" size="2" value="$gravatar_size" /> pixel~,
			name => 'gravatar_size',
			validate => 'number',
		},
		{
			description => $admin_txt{'grav4'},
			input_html => qq~<select name="gravatar_rating">
  <option value="G" ${isselected($gravatar_rating eq 'G')}>G</option>
  <option value="PG" ${isselected($gravatar_rating eq 'PG')}>PG</option>
  <option value="R" ${isselected($gravatar_rating eq 'R')}>R</option>
  <option value="X" ${isselected($gravatar_rating eq 'X') }>X</option>
</select>~,
			name => 'gravatar_rating',
			validate => 'text',
		},
	    {
			description => $admin_txt{'grav5'},
			input_html => qq~<input type="text" name="gravatar_defaulturl" size="40" value="$gravatar_defaulturl" />~,
			name => 'gravatar_defaulturl',
			validate => 'text,null',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'extendedprofiles' => 'Use Extended Profiles?<br /><span class="small">If enabled an additional item called "Profile Fields" will be shown on left side. There you can add functions to the users proflies.<br />Leave this unchecked if you don\'t use this feature to save server load!</span>',
</search for>

<add after>
'grav1' => 'Enable Members to select Gravatar:<br /><span class ="small">Check this if want to give members the choice to use the Gravatar service.</span>',
'grav2' => 'Enable Gravatar for all members:<br /><span class ="small">Check this if you want to force all members to use the Gravatar service.<br /><b>Note:</b> Checking this will disable the default avatar feature.</span>',
'grav3' => 'Gravatar Size:<br /><span class ="small">Valid values are from 1 to 80.<br ><b>Note:</b> Using anything more than 80 may cause the image to destort.</span>',
'grav4' => 'Gravatar Rating:<br /><span class ="small"></span>Set the maximum Gravatar rating. If the Gravatar has a rating higher than is allowed the default image will be used.',
'grav5' => 'Gravatar Default Image:<br /><span class ="small">This is used for members who haven\'t got a Gravatar, or the Gravatar has a rating higher than is allowed by the rating parameter.<br />- This must be a complete URL (e.g. http://mysite.com/myimage.jpg)<br />- Or you may also use Identicon, MonsterID and Wavatar, by entering one of the following values respectively:<br />indenticon monsterid wavatar<br />- If left empty, no default image will be displayed.</span>',
</add after>

<search for>
'profile' => 'Profile',
</search for>

<add after>
'gravatar' => 'Gravatar',
</add after>

<edit file>
Languages/English/Profile.lng
</edit file>

<search for>
'229' => 'Personalized Picture',
</search for>

<add after>
'grav1' => 'Gravatar',
'grav2' => 'Check this to use <a href="http://gravatar.com" target="_blank"><b>Gravatar</b></a> (<b>g</b>lobally <b>r</b>ecognized <b>avatar</b>).<br />If you already have a <a href="http://gravatar.com" target="_blank"><b>Gravatar</b></a> account, you should see your picture on the right. If you can\'t see an image, or you can see a default image, you can sign up for a free account on their website here: <a href="http://gravatar.com" target="_blank"><b>http://gravatar.com</b></a><br /><b>Note:</b> Checking this will override your Personalized Picture.',
'grav3' => 'The forum is set by default for all members to use <a href="http://gravatar.com" target="_blank"><b>Gravatar</b></a> (<b>g</b>lobally <b>r</b>ecognized <b>avatar</b>).<br />If you already have a <a href="http://gravatar.com" target="_blank"><b>Gravatar</b></a> account, you should see your picture on the right. If you can\'t see an image, or you can see a default image, you can sign up for a free account on their website here: <a href="http://gravatar.com" target="_blank"><b>http://gravatar.com</b></a>',
</add after>

<edit file>
Sources/Load.pl
</edit file>

<search for>
	if ($showuserpic && $allowpics) {
		${$uid.$user}{'userpic'} ||= 'blank.gif';
		${$uid.$user}{'userpic'} = qq~<img src="~ .(${$uid.$user}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$user}{'userpic'} : "$facesurl/${$uid.$user}{'userpic'}") . qq~" name="avatar_img_resize" alt="" border="0" style="display:none" /><br />~;
	} else {
		${$uid.$user}{'userpic'} = '<br />';
	}
</search for>

<replace>
	if ($showuserpic && $allowpics && ${$uid.$user}{'gravatar'} == 0 && !$enable_gravatarall) {
		${$uid.$user}{'userpic'} ||= 'blank.gif';
		${$uid.$user}{'userpic'} = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="~ .(${$uid.$user}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$user}{'userpic'} : "$facesurl/${$uid.$user}{'userpic'}") . qq~" name="avatar_img_resize" alt="" border="0" style="display:none" /></a><br />~;
	} elsif ($showuserpic && $allowpics && ($enable_gravatar && ${$uid.$user}{'gravatar'} == 1 || $enable_gravatarall)) {
	    use URI::Escape qw(uri_escape);
        use Digest::MD5 qw(md5_hex);
        if (!$gravatar_defaulturl) {
             $gravatar_defaulturl = "$facesurl/blank.gif";
        }
        $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex(lc ${$uid.$user}{'email'})."&rating=".$gravatar_rating."&default=".uri_escape($gravatar_defaulturl)."&size=".$gravatar_size;
		${$uid.$user}{'userpic'} = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="$grav_url" alt="" border="0" /></a><br />~;
	} else {
		${$uid.$user}{'userpic'} = '<br />';
	}
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
			$pic = "$facesurl/${$uid.$user}{'userpic'}";
		}

		$showProfile .= qq~
</search for>

<replace>
			$pic = "$facesurl/${$uid.$user}{'userpic'}";
		}

        if (!$enable_gravatarall) {
		$showProfile .= qq~
</replace>

<search for>
			<input type="file" name="file_avatar" size="50" />~ : "") . qq~
		</td>
	</tr>~;
	}
</search for>

<add after>
}

	if ($allowpics && $enable_gravatarall) {
	    if (!$gravatar_defaulturl) {
             $gravatar_defaulturl = "$facesurl/blank.gif";
        }
        $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex(lc ${$uid.$user}{'email'})."&rating=".$gravatar_rating."&default=".uri_escape($gravatar_defaulturl)."&size=".$gravatar_size;
		$showProfile .= qq~
	<tr class="windowbg">
		<td align="left"><b>$profile_txt{'229'}: $profile_txt{'grav1'}</b><br /><span class="small">$profile_txt{'grav3'}</span></td>
		<td align="left"><img src="$grav_url" alt="" border="0" /></td>
	</tr>~;
	} elsif ($allowpics && $enable_gravatar) {
		     if (!$gravatar_defaulturl) {
                  $gravatar_defaulturl = "$facesurl/blank.gif";
             }
        $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex(lc ${$uid.$user}{'email'})."&rating=".$gravatar_rating."&default=".uri_escape($gravatar_defaulturl)."&size=".$gravatar_size;
		$showProfile .= qq~
	<tr class="windowbg">
		<td align="left"><label for="gravatar"><b>$profile_txt{'grav1'}:</b><br /><span class="small">$profile_txt{'grav2'}</span></label></td>
		<td align="left"><input type="checkbox" name="gravatar" id="gravatar" value="1"~ . (${$uid.$user}{'gravatar'} ? ' checked="checked"' : '') . qq~ /> <img src="$grav_url" alt="" border="" /></td>
	</tr>~;
	}
	
</add after>

<search for>
	${$uid.$user}{'userpic'} = $member{'userpic'};
</search for>

<add after>
	${$uid.$user}{'gravatar'} = $member{'gravatar'} ? 1 : 0;
</add after>

<search for>
	if ($allowpics) {
		if (${$uid.$user}{'userpic'} eq "blank.gif") {
			$pic = qq~<img src="$imagesdir/nn.gif" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		} elsif (${$uid.$user}{'userpic'} =~ /^https?:\/\//) {
			$pic = qq~<img src="${$uid.$user}{'userpic'}" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		} else {
			$pic = qq~<img src="$facesurl/${$uid.$user}{'userpic'}" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		}
		$pic_row = qq~<div style="float: left; width: 20%; text-align: center; padding: 5px 5px 5px 0px;">
			$pic
			</div>~;
	}
</search for>

<replace>
	if ($allowpics) {
		if (${$uid.$user}{'userpic'} eq "blank.gif" && ${$uid.$user}{'gravatar'} == 0 && !$enable_gravatarall) {
			$pic = qq~<img src="$imagesdir/nn.gif" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		} elsif (${$uid.$user}{'userpic'} =~ /^https?:\/\// && ${$uid.$user}{'gravatar'} == 0 && !$enable_gravatarall) {
			$pic = qq~<img src="${$uid.$user}{'userpic'}" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		} elsif ($enable_gravatar && ${$uid.$user}{'gravatar'} == 1 || $enable_gravatarall) {
        if (!$gravatar_defaulturl) {
             $gravatar_defaulturl = "$facesurl/blank.gif";
        }
        $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex(lc ${$uid.$user}{'email'})."&rating=".$gravatar_rating."&default=".uri_escape($gravatar_defaulturl)."&size=".$gravatar_size;
		$pic = qq~<img src="$grav_url" alt="" border="0" />~;
	    } else {
			$pic = qq~<img src="$facesurl/${$uid.$user}{'userpic'}" name="avatar_img_resize" alt="" border="0" style="display:none" />~;
		}
		$pic_row = qq~<div style="float: left; width: 27%; text-align: center; padding: 5px 0px 5px 0px;">
			$pic
			</div>~;
	}
</replace>

<edit file>
Sources/System.pl
</edit file>

<search for>
	my @tags = qw(realname password position addgroups email hidemail regdate regtime regreason location bday gender userpic usertext signature template language stealth webtitle weburl icq aim yim skype myspace facebook msn gtalk timeselect timeformat timeoffset dsttimeoffset dynamic_clock postcount lastonline lastpost lastim im_ignorelist im_popup im_imspop pmmessprev pmviewMess pmactprev notify_me board_notifications thread_notifications favorites buddylist cathide pageindex reversetopic postlayout sesquest sesanswer session lastips onlinealert offlinestatus awaysubj awayreply awayreplysent spamcount spamtime);
</search for>

<add after>
	push(@tags, "gravatar");
</add after>