<id>
Gravatar Support - Version 1.0 for YaBB 2.4 - Avatars in Member List Patch
</id>

<version>
1.0
</version>

<mod info>
Adds Gravatar support to YaBB.

Mod History:
Version 1.0 - First Release - 23rd June 2009

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.
 
Files to edit 
Admin/NewSettings.pl
Admin/Settings_Main.pl
Languages/English/Admin.lng
Languages/English/Profile.lng
Sources/MemberList.pl
</mod info>

<author>
Derek Barnstorm
</author>

<homepage>
http://www.boardmod.org
</homepage>

<edit file>
Admin/NewSettings.pl
</edit file>

<search for>
\$gravatar_size = $gravatar_size;			          # Set the size of the Gravatar
</search for>

<add after>
\$gravatar_sizeml = $gravatar_sizeml;			      # Set the size of the Gravatar in the member list
</add after>

<edit file>
Admin/Settings_Main.pl
</edit file>

<search for>
		{
			description => $admin_txt{'grav3'},
			input_html => qq~<input type="text" name="gravatar_size" size="2" value="$gravatar_size" /> pixel~,
			name => 'gravatar_size',
			validate => 'number',
		},
</search for>

<add after>
		{
			description => $admin_txt{'grav6'},
			input_html => qq~<input type="text" name="gravatar_sizeml" size="2" value="$gravatar_sizeml" /> pixel~,
			name => 'gravatar_sizeml',
			validate => 'number',
		},
</add after>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
'grav5' => 'Gravatar Default Image:<br /><span class ="small">This is used for members who haven\'t got a Gravatar, or the Gravatar has a rating higher than is allowed by the rating parameter.<br />- This must be a complete URL (e.g. http://mysite.com/myimage.jpg)<br />- Or you may also use Identicon, MonsterID and Wavatar, by entering one of the following values respectively:<br />indenticon monsterid wavatar<br />- If left empty, no default image will be displayed.</span>',
</search for>

<add after>
'grav6' => 'Gravatar Size in Member List:<br /><span class ="small">Valid values are from 1 to 80.<br ><b>Note:</b> Using anything more than 80 may cause the image to destort.</span>',
</add after>

<edit file>
Sources/MemberList.pl
</edit file>

<search for>
		if ($showuserpicml && $allowpics) {
		    ${$uid.$user}{'userpic'} ||= 'blank.gif';
            ${$uid.$user}{'userpic'} = qq~<td align="center" class="windowbg2"><a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="~ .(${$uid.$user}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$user}{'userpic'} : "$facesurl/${$uid.$user}{'userpic'}") . qq~" name="avatarml_img_resize" alt="" border="0" style="display:none" /></a></td>~;
        } else {
		    ${$uid.$user}{'userpic'} = '<td align="center" class="windowbg2">&nbsp;</td>';
	    }
	    $pic = ${$uid.$user}{'userpic'};
</search for>

<replace>
        if ($showuserpicml && $allowpics && ${$uid.$user}{'gravatar'} == 0 && !$enable_gravatarall) {
		    ${$uid.$user}{'userpic'} ||= 'blank.gif';
		    ${$uid.$user}{'userpic'} = qq~<td align="center" class="windowbg2"><a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="~ .(${$uid.$user}{'userpic'} =~ m~\A[\s\n]*https?://~i ? ${$uid.$user}{'userpic'} : "$facesurl/${$uid.$user}{'userpic'}") . qq~" name="avatarml_img_resize" alt="" border="0" style="display:none" /></a></td>~;
	    } elsif ($showuserpicml && $allowpics && ($enable_gravatar && ${$uid.$user}{'gravatar'} == 1 || $enable_gravatarall)) {
             if (!$gravatar_defaulturl) {
                  $gravatar_defaulturl = "$facesurl/blank.gif";
            }
            $grav_url = "http://www.gravatar.com/avatar.php?gravatar_id=".md5_hex(lc ${$uid.$user}{'email'})."&rating=".$gravatar_rating."&default=".uri_escape($gravatar_defaulturl)."&size=".$gravatar_sizeml;
		    ${$uid.$user}{'userpic'} = qq~<td align="center" class="windowbg2"><a href="$scripturl?action=viewprofile;username=$useraccount{$user}"><img src="$grav_url" alt="" border="0" /></a></td>~;
	    } else {
		    ${$uid.$user}{'userpic'} = '<td align="center" class="windowbg2">&nbsp;</td>';
	    }
	    $pic = ${$uid.$user}{'userpic'};
</replace>